routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\HomeController;
use App\Http\Controllers\RoleController;
use App\Http\Controllers\UserController;
use App\Http\Controllers\PermissionController;
use App\Http\Controllers\PostController;
use App\Http\Controllers\AdminController;
use App\Http\Controllers\ProvinceController;
use App\Http\Controllers\AreaController;
use App\Http\Controllers\StoreController;
use App\Http\Controllers\TagController;
use App\Http\Controllers\SubtagController;
use App\Http\Controllers\ColorController;
use App\Http\Controllers\sizeController;
use App\Http\Controllers\ProductController;
use App\Http\Controllers\ImageUploadController;
use App\Http\Controllers\frontcontroller;










/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Route::get('/', [frontcontroller::class, 'index']);


Auth::routes();



Route::get('/home', [HomeController::class, 'index'])->name('home');

//admin route
Route::group(['middleware' => ['auth']], function() {
    Route::resource('users', UserController::class);
    Route::resource('roles', RoleController::class);
    Route::resource('permissions', PermissionController::class);
    Route::resource('posts', PostController::class);
    Route::resource('province', ProvinceController::class) ;
    Route::resource('area', AreaController::class) ;
    Route::resource('store', StoreController::class) ;
    Route::resource('tag', TagController::class) ;
    Route::resource('subtag', SubtagController::class) ;
    Route::resource('color', ColorController::class) ;
    Route::resource('size', sizeController::class) ;
    Route::resource('product', ProductController::class) ;

});

//front route
Route::get('/stores',[frontcontroller::class, 'store'])->name('store');
Route::get('/subtagshow/{id}',[frontcontroller::class, 'subtagshow'])->name('subtag'); // Show All subtags store
Route::get('/products',[frontcontroller::class, 'products'])->name('products');  // Show All Product
Route::get('/product_detail/{id}',[frontcontroller::class, 'product_detail'])->name('product_detail'); // show one product

//cart
Route::get('cart', [ProductController::class, 'cart'])->name('cart');
Route::get('add-to-cart/{id}', [ProductController::class, 'addToCart'])->name('add.to.cart');
Route::patch('update-cart', [ProductController::class, 'updatecart'])->name('update.cart');
Route::delete('remove-from-cart', [ProductController::class, 'removecart'])->name('remove.from.cart');
Route::get('product-checkout', [ProductController::class, 'productcheckout'])->name('product-checkout');


// Route::resource('/{page}', AdminController::class);

Route::get('/', function () {
    $provinces = App\Models\province::all();
    return view('indexss',['provinces' => $provinces]);
});

Route::get('getarea/{id}', function ($id) {
    $area = App\Models\area::where('province_id',$id)->get();
    return response()->json($area);
});

app/Models/product.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use App\Traits\Multitenantable;


class product extends Model
{
    use HasFactory;
    protected $fillable =
    ['name'
    ,'price'
    ,'description'
    ,'store_id'
    ,'subtag_id'
    ,'images'
    ,'created_by_user_id'];



    public function user()
    {
        return $this->belongsTo(User::class,'created_by_user_id');
    }


    public function store()
    {
        return $this->belongsTo(store::class);
    }



    public function subtag()
    {
        return $this->belongsTo(subtag::class);
    }


    public function comments()
    {
        return $this->hasMany(Comment::class)->whereNull('parent_id');
    }



    public function sizes()
    {
        return $this->belongsToMany(size::class,'products_sizes');
    }


    public function colors()
    {
        return $this->belongsToMany(color::class,'colors_products');
    }


}

app/Http/Controllers/ProductController.php
<?php

namespace App\Http\Controllers;

use App\Models\product;
use App\Models\subtag;
use App\Models\color;
use App\Models\size;
use Illuminate\Support\Facades\Auth;

use Illuminate\Http\Request;

class ProductController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {

        $products = product::where('created_by_user_id',Auth::id())->orderBy('id')->paginate(5);
        return view('product.index', compact('products'));

        }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $subtags = subtag::all();
        $colors = color::all();
        $sizes = size::all();

      if($subtags->count() == 0)
    {
return redirect()->route('subtag.create');
    }

if($colors->count() == 0)
    {
return redirect()->route('color.create');
    }

        return view('product.create')
        ->with('subtags', $subtags)
        ->with('colors', $colors)
        ->with('sizes', $sizes);

    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        // dd($request->all());

        $request->validate([
            'name'=>'required',
            'price'=>'required',
            'description'=>'required',
            'subtag_id'=>'required',
            'colors'=>'required',
            'sizes'=>'required',
            'images'=>'required',

            ]);

            $image_names = [];
            // loop through images and save to /uploads directory
            foreach ($request->file('images') as $image) {
                $name = $image->getClientOriginalName();
                $image->move('uploads/products', $name);
                $image_names[] = $name;
            }


            // $product=product::create($request->all([
                //    'name'=>$request->name
                //    ,'price'=>$request->price
                //    ,'description'=>$request->description
                //    ,'store_id'=>Auth::user()->store->id
                //    ,'subtag_id'=>$request->subtag_id,

                // ]));
            $product = new product();
            $product->name = $request->name;
            $product->price = $request->price;
            $product->description = $request->description;
            $product->store_id = Auth::user()->store->id;
            $product->subtag_id = $request->subtag_id;
            $product->images = json_encode($image_names);
            $product->created_by_user_id=Auth::id();

            $product->save();

            // $product=product::create($request->except('store_id') + [
            //     'store_id'=>Auth::user()->store->id
            //  ]);

            $product->colors()->attach($request->colors);
            $product->sizes()->attach($request->sizes);


            return redirect()
            ->route('product.index')
            ->with('success', 'product create successfully');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\product  $product
     * @return \Illuminate\Http\Response
     */
    public function show( $id)
    {
        $product = product::find($id);



        return view('product.show', compact('product'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\product  $product
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $subtags = subtag::all();
        $colors = color::all();
        $sizes = size::all();

      if($subtags->count() == 0)
    {
return redirect()->route('subtag.create');
    }

if($colors->count() == 0)
    {
return redirect()->route('color.create');
    }

    $product = product::find($id);

        return view('product.edit')
        ->with('product', $product)
        ->with('subtags', $subtags)
        ->with('colors', $colors)
        ->with('sizes', $sizes);

     }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\product  $product
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request,$id)
    {
        $product = product::find($id);
        $this->validate($request, [
            'name'=>'required',
            'price'=>'required',
            'description'=>'required',
            'subtag_id'=>'required',
            'colors'=>'required',
            'sizes'=>'required',

        ]);
        //dd($request->all());

        // if ($request->has('photo')) {
        //     $photo = $request->photo;
        //     $newphoto = time() . $photo->getClientOriginalName();
        //     // عم يعطيني اسم الصورة بدون امتداد وعم يدمجها مع الوقت مشان مايصير في تكرار
        //     $photo->move('uploads/stores', $newphoto);
        // }

        $product->update($request->except('store_id') + [
            'store_id'=>Auth::user()->store->id
                         ]);

        // $store->save();


        $product->colors()->sync($request->colors); // مشان يعدل كل colors ويخزنها
        $product->sizes()->sync($request->sizes); // مشان يعدل كل colors ويخزنها

        return redirect()
        ->route('product.index')
        ->with('success', 'edit product  successfully');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\product  $product
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {

            product::find($id)->delete();
            return redirect()
            ->route('product.index')
            ->with('success', 'product delete successfully.');

    }

    public function cart()
    {
        return view('cart');
    }
    public function addToCart($id)
    {
        $product = Product::findOrFail($id);

        $cart = session()->get('cart', []);

        if(isset($cart[$id])) {
            $cart[$id]['quantity']++;
        } else {
            $cart[$id] = [
                "name" => $product->name,
                "quantity" => 1,
                "price" => $product->price,
                "image" => $product->image
            ];
        }

        session()->put('cart', $cart);
        return redirect()->back()->with('success', 'Product added to cart successfully!');
    }



    // public function updatecart(Request $request)
    // {
    //     if($request->id && $request->quantity){
    //         $cart = session()->get('cart');
    //         $cart[$request->id]["quantity"] = $request->quantity;
    //         session()->put('cart', $cart);
    //         session()->flash('success', 'Cart updated successfully');
    //     }
    // }



    // public function removecart(Request $request)
    // {
    //     if($request->id) {
    //         $cart = session()->get('cart');
    //         if(isset($cart[$request->id])) {
    //             unset($cart[$request->id]);
    //             session()->put('cart', $cart);
    //         }
    //         session()->flash('success', 'Product removed successfully');
    //     }
    // }


    public function productcheckout()
    {

        return view('product-checkout');

        }

}

resources/views/product/create.blade.php
@extends('layouts.master')
@section('title')
    Create product
@stop

@section('css')
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/css/bootstrap.min.css" rel="stylesheet"
        integrity="sha384-1BmE4kWBq78iYhFldvKuhfTAU6auU8tT94WrHftjDbrCEXSU1oBoqyl2QvZ6jIW3" crossorigin="anonymous">
@stop

@section('content')
    <div class="container">
        <div class="justify-content-center">
            @if (count($errors) > 0)
                <div class="alert alert-danger">
                    <strong>Opps!</strong> Something went wrong, please check below errors.<br><br>
                    <ul>
                        @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                        @endforeach
                    </ul>
                </div>
            @endif

            <!-- head -->
            <div class="breadcrumb-header justify-content-between">
                <div class="my-auto">
                    <div class="d-flex">
                        <h4 class="content-title mb-0 my-auto">Manger product</h4><span
                            class="text-muted mt-1 tx-13 mr-2 mb-0">/
                            product create</span>
                    </div>
                </div>
                <div class="d-flex my-xl-auto right-content">
                    <div class="pr-1 mb-3 mb-xl-0">
                        <button type="button" class="btn btn-info btn-icon ml-2"><i
                                class="mdi mdi-filter-variant"></i></button>
                    </div>
                    <div class="pr-1 mb-3 mb-xl-0">
                        <button type="button" class="btn btn-danger btn-icon ml-2"><i class="mdi mdi-star"></i></button>
                    </div>
                    <div class="pr-1 mb-3 mb-xl-0">
                        <button type="button" class="btn btn-warning  btn-icon ml-2"><i
                                class="mdi mdi-refresh"></i></button>
                    </div>
                    <div class="mb-3 mb-xl-0">
                        <div class="btn-group dropdown">
                            <button type="button" class="btn btn-primary">14 Aug 2019</button>
                            <button type="button" class="btn btn-primary dropdown-toggle dropdown-toggle-split"
                                id="dropdownMenuDate" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                <span class="sr-only">Toggle Dropdown</span>
                            </button>
                            <div class="dropdown-menu dropdown-menu-left" aria-labelledby="dropdownMenuDate"
                                data-x-placement="bottom-end">
                                <a class="dropdown-item" href="#">2015</a>
                                <a class="dropdown-item" href="#">2016</a>
                                <a class="dropdown-item" href="#">2017</a>
                                <a class="dropdown-item" href="#">2018</a>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <!-- head -->

            <div class="card">
                <div class="card-body">

                    @if (\Session::has('success'))
                    <div class="alert alert-success">
                        <strong>{{ \Session::get('success') }}</strong>
                    </div>
                @endif
                @if(count($errors) > 0)
                    <div class="alert alert-danger">
                        <ul>
                            @foreach($errors->all() as $error)
                                <li>{{ $error }}</li>
                            @endforeach
                        </ul>
                    </div>
                @endif

                    <form action="{{ route('product.store') }}" method="POST" enctype="multipart/form-data">
                        @csrf

                        <div class="form-group">

                            <input type="text" class="form-control" name="name" placeholder="Name"
                                value="{{ old('name') }}">
                        </div>

                        <div class="form-group">

                            <input type="text" class="form-control" name="price" placeholder="price"
                                value="{{ old('price') }}">
                        </div>

                        <div class="form-group">

                            <input type="text" class="form-control" name="description" placeholder="description"
                                value="{{ old('description') }}">
                        </div>

                        <div class="form-group">



                                <input class="form-control" type="file" id="images" name="images[]" multiple>
                        </div>


                        <div class="form-group" id="accordionExample">

                            <div class="accordion-item">
                                <h2 class="accordion-header" id="headingTwo">
                                    <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse"
                                        data-bs-target="#collapse_subtags" aria-expanded="false"
                                        aria-controls="collapse_subtags">
                                        subtags </button>
                                </h2>
                                <div id="collapse_subtags" class="accordion-collapse collapse" aria-labelledby="headingTwo"
                                    data-bs-parent="#accordionExample">
                                    <div class="accordion-body">

                                        <div class="container">
                                            <div class="row">
                                                @foreach ($subtags as $item)
                                                    <div class="col-lg-3">
                                                        <input type="radio" name="subtag_id" id="{{ $item->name }}"
                                                            value="{{ $item->id }}">
                                                        <label for="{{ $item->name }}"
                                                            style="color: tomato;">{{ $item->name }}</label>

                                                    </div>
                                                @endforeach
                                            </div>
                                        </div>

                                    </div>
                                </div>
                            </div>

                        </div>




                        <div class="form-group" id="accordionExample">

                            <div class="accordion-item">
                                <h2 class="accordion-header" id="headingTwo">
                                    <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse"
                                        data-bs-target="#collapse_colors" aria-expanded="false"
                                        aria-controls="collapse_colors">
                                        colors </button>
                                </h2>
                                <div id="collapse_colors" class="accordion-collapse collapse" aria-labelledby="headingTwo"
                                    data-bs-parent="#accordionExample">
                                    <div class="accordion-body">

                                        <input type="checkbox" id="select-all">

                                        <label for="select-all" style="color: blue;">select-all</label>


                                        <div class="container">
                                            <div class="row">
                                                @foreach ($colors as $item)
                                                    <div class="col-lg-3">
                                                        <input type="checkbox" name="colors[]" id="{{ $item->name }}"
                                                            value="{{ $item->id }}">
                                                        <label for="{{ $item->name }}"
                                                            style="color: tomato;">{{ $item->name }}</label>

                                                    </div>
                                                @endforeach
                                            </div>
                                        </div>

                                    </div>
                                </div>
                            </div>

                        </div>


                        <div class="form-group" id="accordionExample">

                            <div class="accordion-item">
                                <h2 class="accordion-header" id="headingTwo">
                                    <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse"
                                        data-bs-target="#collapse_size" aria-expanded="false" aria-controls="collapse_size">
                                        sizes </button>
                                </h2>
                                <div id="collapse_size" class="accordion-collapse collapse" aria-labelledby="headingTwo"
                                    data-bs-parent="#accordionExample">
                                    <div class="accordion-body">

                                        <input type="checkbox" id="select-all">

                                        <label for="select-all" style="color: blue;">select-all</label>


                                        <div class="container">
                                            <div class="row">
                                                @foreach ($sizes as $item)
                                                    <div class="col-lg-3">
                                                        <input type="checkbox" name="sizes[]" id="{{ $item->name }}"
                                                            value="{{ $item->id }}">
                                                        <label for="{{ $item->name }}"
                                                            style="color: tomato;">{{ $item->name }}</label>

                                                    </div>
                                                @endforeach
                                            </div>
                                        </div>

                                    </div>
                                </div>
                            </div>

                        </div>


                        <div class="card-header">
                            <button type="submit" class="btn btn-primary">Submit</button>
                            <a class="btn btn-danger" href="{{ route('product.index') }}">Back</a>
                        </div>

                    </form>

                </div>



            </div>
        </div>
    </div>
    </div>
@endsection





@section('js')

    <script>
        document.getElementById('select-all').onclick = function() {
            var checkboxes = document.querySelectorAll('input[type="checkbox"]');
            for (var checkbox of checkboxes) {
                checkbox.checked = this.checked;
            }
        }
    </script>
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>


    <script src="https://cdn.jsdelivr.net/npm/@popperjs/core@2.10.2/dist/umd/popper.min.js"
        integrity="sha384-7+zCNj/IqJ95wo16oMtfsKbZ9ccEh31eOz1HGyDuCQ6wgnyJNSYdrPa03rtR1zdB" crossorigin="anonymous">
    </script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.min.js"
        integrity="sha384-QJHtvGhmr9XOIpI6YVutG+2QOK9T+ZnN4kzFN1RtK3zEFEIsxhlmWl5/YESvpZ13" crossorigin="anonymous">
    </script>

@endsection

resources/views/product/show.blade.php
@extends('layouts.master')
@section('title')
Show product
@stop
@section('content')
    <div class="container">
        <div class="justify-content-center">
            @if (\Session::has('success'))
                <div class="alert alert-success">
                    <p>{{ \Session::get('success') }}</p>
                </div>
            @endif


            <!-- head -->
            <div class="breadcrumb-header justify-content-between">
                <div class="my-auto">
                    <div class="d-flex">
                        <h4 class="content-title mb-0 my-auto"> Manger products</h4><span
                            class="text-muted mt-1 tx-13 mr-2 mb-0">/ Show products</span>
                    </div>
                </div>
                <div class="d-flex my-xl-auto right-content">
                    <div class="pr-1 mb-3 mb-xl-0">
                        <button type="button" class="btn btn-info btn-icon ml-2"><i
                                class="mdi mdi-filter-variant"></i></button>
                    </div>
                    <div class="pr-1 mb-3 mb-xl-0">
                        <button type="button" class="btn btn-danger btn-icon ml-2"><i class="mdi mdi-star"></i></button>
                    </div>
                    <div class="pr-1 mb-3 mb-xl-0">
                        <button type="button" class="btn btn-warning  btn-icon ml-2"><i
                                class="mdi mdi-refresh"></i></button>
                    </div>
                    <div class="mb-3 mb-xl-0">
                        <div class="btn-group dropdown">
                            <button type="button" class="btn btn-primary">14 Aug 2019</button>
                            <button type="button" class="btn btn-primary dropdown-toggle dropdown-toggle-split"
                                id="dropdownMenuDate" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                <span class="sr-only">Toggle Dropdown</span>
                            </button>
                            <div class="dropdown-menu dropdown-menu-left" aria-labelledby="dropdownMenuDate"
                                data-x-placement="bottom-end">
                                <a class="dropdown-item" href="#">2015</a>
                                <a class="dropdown-item" href="#">2016</a>
                                <a class="dropdown-item" href="#">2017</a>
                                <a class="dropdown-item" href="#">2018</a>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <!-- head -->

            <div class="card">

                <div class="card-body">
                    <div class="lead">
                        <strong>id:</strong>
                        {{ $product->id }}
                    </div>
                    <div class="lead">
                        <strong>Name:</strong>
                        {{ $product->name }}
                    </div>
                    <div class="lead">
                        <strong>description:</strong>
                        {{$product->description}}
                    </div>
                    <div class="lead">
                        <strong>address:</strong>
                        {{  $product->address }}
                    </div>
                    <div class="lead">
                        <strong>price:</strong>
                        {{  $product->price }}
                    </div>
                    <div class="lead">
                        <strong>photo:</strong>

                        <img style="width: 200px;height:100px" src="{{$product->images }}"
                        alt="erorr">
                    </div>

                                                         <td>
                                                            <div class="container">
                                                                <div class="row">
                                                                    <strong>colors:</strong>

                                                                    @foreach ($product->colors as $color)
                                                                        <div class="col-lg-6">
                                                                            {{ $color->name }}
                                                                        </div>
                                                                    @endforeach
                                                                </div>
                                                            </div>
                                                        </td>
                                                        <td>
                                                            <div class="container">
                                                                <div class="row">
                                                                    <strong>sizes:</strong>

                                                                    @foreach ($product->sizes as $size)
                                                                    <div class="col-lg-6">
                                                                        {{ $size->name }}
                                                                    </div>
                                                                @endforeach
                                                                </div>
                                                            </div>
                                                        </td>
                    <div class="card-header">
                        <span class="float-right">
                            <a class="btn btn-danger" href="{{ route('product.index') }}">Back</a>
                        </span>
                    </div>

                </div>
            </div>
        </div>
    </div>
@endsection